package com.company;

import java.util.ArrayList;
import java.util.List;

public class StudentService {
    private List<Student> studentList;

    public StudentService() {
        studentList = new ArrayList<>();
    }

    public StudentService(List<Student> studentList) {
        this.studentList = studentList;
    }

    public void addStudent(Student student){
        studentList.add(student);
    }

    public List<String> fetchStudentSurnames(){
        List<String> namesList = new ArrayList<>();
        for (Student student : studentList){
            namesList.add(student.getSurname());
        }
        return namesList;
    }

    public int fetchStudentsAmount(){
        return studentList.size();
    }

    public void showStudentNames(){
        for(int i = 0; i < studentList.size(); i++){
            System.out.println((i+1) + " " + studentList.get(i).getName() + " " + studentList.get(i).getSurname());
        }
    }

    public void removeStudent(int index){
        studentList.remove(index);
    }

    public void showStudentsWithSurname(String surname){
        System.out.println("Students with " + surname + " as surname:");
        for(Student student : studentList){
            if (student.getSurname().equals(surname)){
                student.display();
            }
        }
    }

    public List<Student> fetchStudentsWithGradeHigherThan(double grade) {
        List<Student> studentsWithHigherGradeList = new ArrayList<>();
        for(Student student : studentList){
            if(student.calculateFinalGrade() > grade){
                studentsWithHigherGradeList.add(student);
            }
        }
        return studentsWithHigherGradeList;
    }


}
